diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index 15ee13740..651e4d8ba 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -13,13 +14,15 @@ import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     public static final int DIRECTION_SOUTH = 0;
@@ -39,7 +42,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
         boolean isOpened = isTrapdoorOpen(meta);
         boolean isPowered = world.hasNeighborSignal(tilePos);
@@ -60,7 +63,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
 
         if (isTrapdoorOpen(meta)) {
@@ -80,36 +83,36 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int meta = source.getBlockData(tilePos);
-        float thickness = 3/16f;
+        float thickness = 3 / 16f;
 
         if (isTrapdoorOpen(meta)) {
             return switch (meta & MASK_DIRECTION) {
-                case DIRECTION_SOUTH -> AABB.fromPool(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
-                case DIRECTION_NORTH -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
-                case DIRECTION_EAST -> AABB.fromPool(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);  // West
-                default -> AABB.fromPool(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
+                case DIRECTION_SOUTH -> new AABBd(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
+                case DIRECTION_NORTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
+                case DIRECTION_EAST -> new AABBd(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);  // West
+                default -> new AABBd(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
             };
         } else {
             if (isUpperHalf(meta)) {
-                return AABB.fromPool(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
+                return new AABBd(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
             } else {
-                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
+                return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
             }
         }
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
             onInteracted(world, tilePos, player, null, 0.0, 0.0);
         }
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if (this.material != Material.metal && this.material != Material.steel) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        if (this.material != Materials.METAL && this.material != Materials.STEEL) {
             int data = world.getBlockData(tilePos);
             world.setBlockDataNotify(tilePos, data ^ MASK_OPEN);
             world.playBlockEvent(player, tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
@@ -119,8 +122,8 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
-        if (this.material != Material.metal && this.material != Material.steel) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+        if (this.material != Materials.METAL && this.material != Materials.STEEL) {
             int data = world.getBlockData(tilePos);
             world.setBlockDataNotify(tilePos, data ^ MASK_OPEN);
             world.playBlockEvent(null, tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
@@ -128,13 +131,13 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         if (world.isClientSide) {
             return;
         }
 
         Block<?> block = Blocks.getBlock(id);
-        if ((this.material != Material.metal && this.material != Material.steel && block != null && block.isSignalSource()) || ((this.material == Material.metal || this.material == Material.steel) && (block == null || block.isSignalSource()))) {
+        if ((this.material != Materials.METAL && this.material != Materials.STEEL && block != null && block.isSignalSource()) || ((this.material == Materials.METAL || this.material == Materials.STEEL) && (block == null || block.isSignalSource()))) {
             int meta = world.getBlockData(tilePos);
             boolean isOpened = isTrapdoorOpen(meta);
             boolean isPowered = world.hasNeighborSignal(tilePos);
@@ -147,7 +150,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = getMetaForDirection(player == null ? side.getDirection().getOpposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
         if (player != null && player.getVerticalPlacementDirection(side, yHit) == Direction.UP) {
             meta = setUpperHalf(meta, true);
@@ -156,11 +159,12 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public boolean isClimbable(@NotNull World world, @NotNull TilePos tilePos) {
-        Block<?> block = world.getBlock(tilePos.down());
+    public boolean isClimbable(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        Block<?> block = world.getBlock(tilePos.down(queryPos));
         int meta = world.getBlockData(tilePos);
         if (isTrapdoorOpen(meta) && (block != null && block.getLogic() instanceof BlockLogicLadder ladder)) {
-            Side ladderSide = ladder.getSideFromMeta(world.getBlockData(tilePos.down()));
+            Side ladderSide = ladder.getSideFromMeta(world.getBlockData(tilePos.down(queryPos)));
             Direction trapdoorDirection = getDirectionForMeta(meta);
             return ladderSide.getDirection() == trapdoorDirection.getOpposite();
         }
@@ -215,11 +219,11 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
 
     @Override
     public boolean canBePainted() {
-        return this.material == Material.wood;
+        return this.material == Materials.WOOD;
     }
 
     @Override
-    public void setColor(World world, @NotNull TilePos tilePos, DyeColor color) {
+    public void setColor(World world, @NotNull TilePosc tilePos, DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_PAINTED.id(), meta & 0xF | color.blockMeta << 4);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
index cfb05d68b..dd15b32ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
@@ -8,7 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -18,7 +18,7 @@ public class BlockLogicTrapDoorPainted extends BlockLogicTrapDoor implements IPa
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         return itemStack.getMetadata() | super.getPlacedData(player, itemStack, world, tilePos, side, xHit, yHit);
     }
 
@@ -44,13 +44,13 @@ public class BlockLogicTrapDoorPainted extends BlockLogicTrapDoor implements IPa
     }
 
     @Override
-    public void removeDye(World world, @NotNull TilePos tilePos) {
+    public void removeDye(World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_OAK.id(), meta & 0xF);
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
index 92ca36df5..68c92b2e3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -40,7 +41,7 @@ public class BlockLogicTrommel extends BlockLogicRotatable
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getTileEntity(tilePos);
             player.displayTrommelScreen(tileEntityTrommel);
@@ -49,13 +50,13 @@ public class BlockLogicTrommel extends BlockLogicRotatable
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
+	public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand)
     {
         if(!this.isActive)
             return;
-        double xPos = (double) tilePos.x + rand.nextFloat();
-        double yPos = (double) tilePos.y + rand.nextFloat() * 0.5D + 1D;
-        double zPos = (double) tilePos.z + rand.nextFloat();
+        double xPos = (double) tilePos.x() + rand.nextFloat();
+        double yPos = (double) tilePos.y() + rand.nextFloat() * 0.5D + 1D;
+        double zPos = (double) tilePos.z() + rand.nextFloat();
         world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
     }
     
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
index b858c52d5..886abf81b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class BlockLogicVeryRotatable
@@ -17,14 +17,14 @@ public abstract class BlockLogicVeryRotatable
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         final @NotNull Direction direction = mob.getPlacementDirection(side).getOpposite();
 
         world.setBlockDataNotify(tilePos, setDirection(0, direction));
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         world.setBlockDataNotify(tilePos, setDirection(0, side.getDirection()));
     }
 
